//+------------------------------------------------------------------+
//|                                                       SCI_v1.mq4 |
//|                         Squelch Control Indicator by John Ehlers |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window

#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

//---- input parameters
extern int Price=4;
extern int Squelch=20;
//---- buffers
double   HighBuffer[];
double   LowBuffer[];
double   Value1[],
         InPhase[],
         Quadrature[],
         Phase[],
         DeltaPhase[],
         period[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(8); 
   
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
    
   SetIndexBuffer(0,HighBuffer);
   SetIndexBuffer(1,LowBuffer);
   SetIndexBuffer(2,Value1);
   SetIndexBuffer(3,InPhase);
   SetIndexBuffer(4,Quadrature);
   SetIndexBuffer(5,Phase);
   SetIndexBuffer(6,DeltaPhase);
   SetIndexBuffer(7,period);
   
//---- name for DataWindow and indicator subwindow label
   short_name="SCI";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,40);
   SetIndexDrawBegin(1,40);
   
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  limit, counted_bars=IndicatorCounted(),i,shift;
   

//---- TODO: add your code here
int Length = 40;
if (counted_bars==0) counted_bars=Length+1;
limit=(Bars-counted_bars);

for (shift=limit; shift>=0;shift--)
{

// Compute InPhase and Quadrature components

Value1[shift] = iMA(NULL,0,1,0,0,Price,shift) - iMA(NULL,0,1,0,0,Price,shift+6);
double Value2 =Value1[shift+3];
double Value3 =0.75*(Value1[shift] - Value1[shift+6]) + 0.25*(Value1[shift+2] - Value1[shift+4]);
InPhase[shift] = 0.33*Value2 + 0.67*InPhase[shift+1];
Quadrature[shift] = 0.2*Value3 + 0.8*Quadrature[shift+1];

// Use ArcTangent to compute the current phase
if (MathAbs(InPhase[shift] +InPhase[shift+1]) > 0) 
   Phase[shift] = 180.0/3.14159*MathArctan(MathAbs((Quadrature[shift]+Quadrature[shift+1]) / (InPhase[shift]+InPhase[shift+1])));

//Print("phase=",Phase[shift]);
// Resolve the ArcTangent ambiguity
if (InPhase[shift] < 0 && Quadrature[shift] > 0) Phase[shift] = 180 - Phase[shift];
if (InPhase[shift] < 0 && Quadrature[shift] < 0) Phase[shift] = 180 + Phase[shift];
if (InPhase[shift] > 0 && Quadrature[shift] < 0) Phase[shift] = 360 - Phase[shift];
//Print("phase=",Phase[shift]);
//Compute a differential phase, resolve phase wraparound, and limit delta phase errors
DeltaPhase[shift] = Phase[shift+1] - Phase[shift];
if (Phase[shift+1] < 90 && Phase[shift] > 270) DeltaPhase[shift] = 360 + Phase[shift+1] - Phase[shift];
if (DeltaPhase[shift] < 1) DeltaPhase[shift] = 1;
if (DeltaPhase[shift] > 60) DeltaPhase[shift] = 60;
//Print("Delphase=",DeltaPhase[shift]);
// Sum DeltaPhases to reach 360 degrees. The sum is the instantaneous period.
int InstPeriod = 0;
double Value4 = 0;
for ( int count = 0; count<=40;count++)
{
Value4 += DeltaPhase[shift+count];
if (Value4 > 360 && InstPeriod == 0) InstPeriod = count;
}

// Resolve Instantaneous Period errors and smooth
int InstPeriod1;
if (InstPeriod == 0) InstPeriod = InstPeriod1;
period[shift] = 0.25*InstPeriod + 0.75*period[shift+1];

if (period[shift] > Squelch)
{
HighBuffer[shift]=High[shift];
LowBuffer[shift]=Low[shift]; 
}
else
{ 
LowBuffer[shift]=High[shift];
HighBuffer[shift]=Low[shift];
}
//Print("period=",period[shift]," instper=",InstPeriod);
InstPeriod1=InstPeriod;   
 //----
}
   return(0);
  }
//+------------------------------------------------------------------+

